<%@Page Description="Localized Page" %>
<%@ OutputCache Duration="0" %>

<%@Import Namespace="System.Globalization"%>
<%@Import Namespace="System.Resources"%>
<%@Import Namespace="System.Threading"%>

<%@Register TagPrefix="Localized" TagName="Search" src="../localize2/search.aspc" %>
<%@Register TagPrefix="Localized" TagName="Flag" src="../localize2/flag.aspc" %>


<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">

<link rel="stylesheet" type="text/css" href="../i18n_styles.css" >
<link rel="stylesheet" type="text/css" href="../news.css" >

<script runat="Server" Language="C#">

ResourceManager rm;

void Page_Init(Object sender, EventArgs args) {
    // Get the ResourceManager from the Application object.
    rm = (ResourceManager) Application["RM"];
    if(rm == null) 
    {
	// Do something sensible if resources are not available.
	Server.Transfer("noresource.aspx");
    }

    // Fill the drop-down list with the supported culture values.
    MyUICulture.Items.Add("Choose another language");
    MyUICulture.Items.Add("de");
    MyUICulture.Items.Add("en-us");
    MyUICulture.Items.Add("ja");
    MyUICulture.AutoPostBack = true;
}

void Page_Load(Object sender, EventArgs args) {
    String SelectedCulture = MyUICulture.SelectedItem.Text;
    if(! SelectedCulture.StartsWith("Choose")) 
    {
	// If another culture was selected, use that instead.
	Thread.CurrentThread.CurrentCulture = new CultureInfo(SelectedCulture);
	Thread.CurrentThread.CurrentUICulture = new CultureInfo(SelectedCulture);
    }

    // Using culture within a script block.
    TopAdRotator.KeywordFilter = Thread.CurrentThread.CurrentUICulture.Name;
    TopAdRotator.AdvertisementFile = "rotator/ads.xml";
}

</script>

<title>Localized Page</title>

</head>


<body>

<center>
<asp:AdRotator id="TopAdRotator" Runat="server"	Target="_newwindow" />
</center>


<h3>
<%--
    Display the flag as declarative control, 
      get the greeting string from a resource.
--%>
<Localized:Flag runat="server"/>
<%=rm.GetString("greeting")%>
</h3>

<%--
    Give the user the opportunity to override browser language.
--%>

<form runat="server">

<asp:DropDownList id="MyUICulture" runat="server"/>

<hr>


<center>

<p>

<table bgcolor="#FFFFFF" cellpadding="5" cellspacing="5" border="0"
    style="border-style:solid; border-width:2; border-color:Wheat"
    width="99%" align=center>

<tr>
<td class="infocol"><%=DateTime.Now.Format("D", CultureInfo.CurrentCulture)%></td>
<td class="contentcol"><%=rm.GetString("article1")%>
	    <br>(<a href="/some/where/else"><%=rm.GetString("more")%></a>)</td>
</tr>

<tr>
<td class="infocol"><%=DateTime.Now.Format("D", CultureInfo.CurrentCulture)%></td>
<td class="contentcol"><%=rm.GetString("article2")%>
	    <br>(<a href="/some/where/else"><%=rm.GetString("more")%></a>)</td>
</tr>

<tr>
<td class="infocol"><%=DateTime.Now.Format("D", CultureInfo.CurrentCulture)%></td>
<td class="contentcol"><%=rm.GetString("article3")%>
	    <br>(<a href="/some/where/else"><%=rm.GetString("more")%></a>)</td>
</tr>

</table>


    <Localized:Search runat="Server" />

</center>

</form>

</body>

</html>






