<%@ Page ClientTarget="downlevel" %>

<html>
<head>
<link rel="stylesheet" href="/quickstart/include/qsstyle.css">

  <script runat="server" language="C#">

      void Calculate_OnClick(Object source, EventArgs e) {
      
      	  if( !Page.IsValid ) {
            Msg.Text = "Please enter all required values";
            return;
          }

          double rateAmount = Double.Parse(Rate.Text);
          double principalAmount = Double.Parse(Principal.Text);
          int  monthCount = Int32.Parse(Months.Text);

          double payment = Calculate(principalAmount, rateAmount, monthCount);
          Msg.Text = "Approximate payment is " + Double.Format(payment, "C") + " monthly";
      }

      double Calculate(double principal, double interestRate, int months) {
      
          // account for interest rates like 9.0, which we'll assume is 9%
          // and 0.9, which we'll also assume is 9%
      	
          if( interestRate >= 1.0 )
              interestRate /= 100.0;

          double rate = (interestRate / 12) + 1.0;
          double top = principal * System.Math.Pow(rate, (double)months);
          double bottom = 0;

          for( int m = months - 1; m > 0; m-- ) {
              bottom += System.Math.Pow(rate, (double)m);
          }

          return top / bottom;
      }

  </script>

</head>

<body>
  <h4>My Web Mortage Calculator</h4>
  
  <form runat="server">
  
    <table style="background-color:#ccccff;">
      <tr>
      	<td>Principal:</td>
      	<td><asp:TextBox id="Principal" runat="server"/></td>
      	<td><ASP:RequiredFieldValidator ControlToValidate="Principal" Display="Static" ErrorMessage="*" runat="server"/></td>
      </tr>
      <tr>	
      	<td>Interest Rate:</td>
      	<td><asp:TextBox id="Rate" runat="server"/></td>
      	<td><ASP:RequiredFieldValidator ControlToValidate="Rate" Display="Static" ErrorMessage="*" runat="server"/> </td>
      </tr>
      <tr>	
      	<td>Months</td>
      	<td><asp:TextBox id="Months" runat="server"/></td>
      	<td><ASP:RequiredFieldValidator ControlToValidate="Months" Display="Static" ErrorMessage="*" runat="server"/></td>
      </tr>
    </table>
    
    <br>
    
    <asp:Button OnClick="Calculate_OnClick" Text="Calculate" runat="server"/>
    
    <br>
  
    <asp:Label id="Msg" runat="server"/>    
    
    <% if( MyWeb.Connected ) { %>
    
      <h4>Related Information</h4>
      
      <ul>
        <li><a href="http://moneycentral.msn.com/smartbuy/home.asp">MSN Saving & Spending Home</a></li>
        <li><a href="http://moneycentral.msn.com">MSN MoneyCentral</a></li>
      </ul>

    <% } %>     
    
  </form> 
  
</body>
</html>
