
<%@ Page Inherits="PortalModule" Description="Main Portal Page" %>

<%@ Register TagPrefix="LoginModule" TagName="LoginModule" Src="modules/login/login.aspx" %>

<html>
<head>
<title>ASP+ PORTAL SITE</title>
</head>

<script language="C#" runat=server>

    protected  void Page_Load(Object sender, EventArgs E) { 

        int pageIndex = 0;  

        if (Request.QueryString["_PageIndex"] != null) 
        {
           SetPageIndex(Request.QueryString["_PageIndex"]);
           pageIndex = Int32.Parse(Request.QueryString["_PageIndex"]);
        }
        else if (Request.Cookies["_PageIndex"] != null) {
            pageIndex = Int32.Parse(Request.Cookies["_PageIndex"].Value);
        }

        if (pageIndex != 0)
        {
            anchorDelete.Visible = true;
            spanDelete.Visible = true;
        }
        else
        {
            anchorDelete.Visible = false;
            spanDelete.Visible = false;
        }

         anchorDelete.HRef = "/quickstart/aspplus/samples/portal/restricted/deletepage.aspx";
         anchorCustomize.HRef = "/quickstart/aspplus/samples/portal/restricted/customize.aspx";
         anchorOptions.HRef = "/quickstart/aspplus/samples/portal/restricted/options.aspx";
         anchorOptions2.HRef = "/quickstart/aspplus/samples/portal/restricted/layout.aspx";
        
        // Dynamically Construct Page Hyperlink List
 
        BuildPaneLinkList(PagePanelLinks, pageIndex);

        // Dynamically Construct Module List for Current Page  

        BuildModuleList(LeftUIModules, UserState["PageModules_" + pageIndex + "L"]);
        BuildModuleList(RightUIModules, UserState["PageModules_" + pageIndex + "R"]);
        DataBind();
    }

    private void BuildModuleList(Control parent, String Modules) {

        if (Modules == null) 
           return; 

        String [] ModuleList = Modules.Split(new char[] {';'});

        if ((UserState["UserId"]=="ANONYMOUS")&&(parent.ID=="LeftUIModules"))
              Login.Visible=true;         

        for (int i=0;i<ModuleList.Length;i++) { 

           String moduleSource = ModuleList[i];

           if ((moduleSource != null)&&(moduleSource != "")&&(moduleSource != "System.DBNull")) {

              Control UIModule = Page.LoadControl(moduleSource);

              parent.Controls.Add(new LiteralControl("<tr><td>"));
              parent.Controls.Add(UIModule);
              parent.Controls.Add(new LiteralControl("</td></tr>"));
           }
        }
    }

    private void BuildPaneLinkList(HtmlContainerControl container, int currentPageIndex) {

        String pageNames = UserState["PageNames"];

        if (pageNames == null)
           return;

        String [] pageList = pageNames.Split(new char[] { ';' });

        if (pageList.Length > 2) 
        {
            anchorAdd.Visible = false;
            spanAdd.Visible = false;
        }
        else 
        {
            anchorAdd.Visible = true;
            spanAdd.Visible = true;
        }

        for (int i=0; i<pageList.Length; i++) {

           if (pageList[i] == null) 
              break;

           if (i == currentPageIndex) {

              container.InnerHtml += "<td align=center bgcolor='" + UserState["HeadColor"] + "' width='20%'>";
              container.InnerHtml += "  <table bgcolor='" + UserState["HeadColor"] + "' border=0 width='100%' cellspacing=0 cellpadding=2>";
              container.InnerHtml += "    <tr align=center>";
              container.InnerHtml += "      <td></a><font face=Arial color='white'><b>&nbsp;"+pageList[i]+"</b></font>&nbsp;</td>";
              container.InnerHtml += "    </tr>";
              container.InnerHtml += "  </table>";
              container.InnerHtml += "</td>";
              container.InnerHtml += "<td width='1%'>&nbsp;</td>";
           }
           else {

              container.InnerHtml += "<td align=center bgcolor='" + UserState["SubheadColor"] + "' width='20%'>";
              container.InnerHtml += "  <table bgcolor='" + UserState["SubheadColor"] + "' border=0 width='100%' cellspacing=0 cellpadding=2>";
              container.InnerHtml += "    <tr align=center>";
              container.InnerHtml += "      <td><font face=Arial size=-1>&nbsp;<a href='default.aspx?_PageIndex=" + i + "'>"+pageList[i]+"</a></font>&nbsp;</td>";
              container.InnerHtml += "    </tr>";
              container.InnerHtml += "  </table>";
              container.InnerHtml += "</td>";
              container.InnerHtml += "<td width='1%'>&nbsp;</td>";
           }
        } 
    }

    private void SignOff_Click(Object sender, EventArgs e) 
   { 
       SetPageIndex("0");
       System.Web.Security.CookieAuthentication.SignOut();
       Response.Redirect("/quickstart/aspplus/samples/portal/default.aspx");
    }

    private void AddPage_Click(Object sender, EventArgs e) {

        if (String.Compare(UserState["UserId"],"ANONYMOUS") == 0)
        {
            Response.Redirect("/quickstart/aspplus/samples/portal/login.aspx");
        }
        else
        {
            String pageNames = UserState["PageNames"] + ";New Page";
            String[] pageList = pageNames.Split(new char[] { ';' });
            int numPages = pageList.Length - 1;
            SetPageIndex(numPages.ToString());
            UserState["PageNames"] = pageNames;
            Response.Redirect("/quickstart/aspplus/samples/portal/restricted/customize.aspx");  
        }
    }

    private void SetPageIndex(String value) 
   {
       HttpCookie PageIndex = new HttpCookie("_PageIndex", value);
       PageIndex.Path = "/";
       PageIndex.Expires = new DateTime(2002, 10, 10);
       Response.AppendCookie(PageIndex);        
   }

</script>


<body bgcolor="<%=UserState["BackColor"]%>" style="margin:0,0,0,0">

   <form runat=server>

      <table border=0 width="100%" cellspacing=0 cellpadding=0 bgcolor="ffffff">
         <tr>
           <td align=left>
            <img src="images\home_<%# UserState["ColorScheme"] %>.gif"> 
           </td>

           <td align=right valign=top style="padding:5,15,5,5">
             <font face=Arial size=-1>
                <a href="default.aspx?default.aspx">Update</a> - 
                <a OnServerClick="SignOff_Click" runat=server>Sign Out</a>
             </font>
           </td>
         </tr>
         <tr height="8"/>
    </table>

    <table border=0 width="100%" bgcolor="ffffff" cellspacing=0 cellpadding=0 >
       <tr>
          <span id="PagePanelLinks" Maintainstate="false" runat=server/>

          <td width="1%">&nbsp;</td>
          <td align=right bgcolor="<%=UserState["SubheadColor"]%>" width="50%" style="padding:0,10,0,0">
             <font size=-1 face=Arial>
                [<a id="anchorAdd" href="" OnServerClick="AddPage_Click" runat="server">Add Page</a>
                 <asp:Label id="spanAdd" Text="&nbsp;-&nbsp;" runat="server"/> 
                 <a id="anchorDelete" href="" runat="server">Delete Page</a>
                 <asp:Label id="spanDelete" Text="&nbsp;-&nbsp;" runat="server"/>
                 <a id="anchorOptions" href="" runat="server">Change Colors</a>]
             </font>
          </td>

       </tr>
       <tr>
          <td width="100%" colspan=11>
             <table border=0 cellspacing=0 width="100%">
                <tr>
                    <td bgcolor="<%=UserState["HeadColor"]%>">
                        <table border=0 cellspacing=0 cellpadding=0>
                            <tr><td height=3></td></tr>
                        </table>
                    </td>
                </tr>
             </table>
          </td>
       </tr>
    </table>

    <table border=0 width="100%" cellspacing=0 cellpadding=0 style="padding:0,0,0,0">
       <tr>
         <td width="1%" valign="top">

            <table border=0 width="100%" cellspacing=10 cellpadding=0 style="padding:0,0,0,0">

            <tr valign="top">
              <td height="10" style="padding-top:5" align="left">
                  <table cellpadding=0 cellspacing=0>
                      <tr>
                          <td><img border=0 src="images\personal.gif"></td>
                          <td><a id="anchorCustomize" runat="server"><img border=0 src="images\content.gif"></a></td>
                          <td><img border=0 src="images\space.gif"></td>
                          <td><a id="anchorOptions2" runat="server"><img border=0 src="images\layout.gif"></a></td>
                      </tr>
                  </table>
              </td>
            </tr>
             <tr> <td>
                <!-- BEGIN DYNAMIC LEFT MODULE LIST -->
                <asp:Panel id="Login" MaintainState="false" visible="false" runat="server">
                    <LoginModule:LoginModule runat="server"/>
                </asp:Panel>
                <span id="LeftUIModules" runat=server/>

                <!-- END DYNAMIC LEFT MODULE LIST -->
               </td> </tr>
            </table>
         </td>
         <td width="99%" valign="top">

            <table border=0 width="100%" cellspacing=10 cellpadding=0>

                <!-- BEGIN DYNAMIC RIGHT MODULE LIST -->

                <span id="RightUIModules" runat=server/>

                <!-- END DYNAMIC RIGHT MODULE LIST -->
 
            </table>
         </td>
      </tr>
    </table>

   </form>

</body>
</html>