<%@ Page Inherits="PortalModule" Description="Site Directory Module Edit Page" %>

<%@ Register TagPrefix="Portal" TagName="PageHeader" Src="/QuickStart/aspplus/samples/portal/include/PageHeader.aspx" %>
<%@ Register TagPrefix="Portal" TagName="EditModuleHeader" Src="/QuickStart/aspplus/samples/portal/include/EditModuleHeader.aspx" %>
<%@ Register TagPrefix="Portal" TagName="EditModuleFooter" Src="/QuickStart/aspplus/samples/portal/include/EditModuleFooter.aspx" %>


<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SQL" %>

<html>
<head>

    <script language="C#" runat="server">

        public ArrayList Source;   

        protected void Page_Load(Object sender, EventArgs e)
        {
           String dsn = (String) ((Hashtable) Context.GetConfig("dsnstore"))["portaldb"];

            SQLDataSetCommand myAdapter = new SQLDataSetCommand();
 
            myAdapter.SelectCommand  = new SQLCommand();
            myAdapter.SelectCommand.ActiveConnection = new SQLConnection(dsn);
            myAdapter.SelectCommand.CommandText = "GetSiteLinks" ;
            myAdapter.SelectCommand.CommandType = CommandType.StoredProcedure;

            DataSet myDataSet = new DataSet();

            myAdapter.FillDataSet(myDataSet, "Results");

           String [] LinkList = null;
           String LinkIndices= UserState["SiteDirectory_Links"];

           if (LinkIndices != null)
               LinkList = LinkIndices.Split(new char[] { ',' });

           RowsCollection rows = myDataSet.Tables[0].Rows;
           DataColumn [] columns  = myDataSet.Tables[0].Columns.All;

           int index = 0;
           Source = new ArrayList();

           for (int i=0; i<rows.Count; i++) {

              Hashtable propertyBag = new Hashtable();

              for (int j=0; j<columns.Length;j++) {
                 Object value = myDataSet.Tables[0].Rows[i][columns[j]];
                 propertyBag[columns[j].ToString()] = (value == null) ? "" : value.ToString();
              }

              propertyBag["IsChecked"] = false;

              if (LinkIndices != null) 
              {
                  if ((index < LinkList.Length) && (i == (Int32.Parse(LinkList[index])-1)))
                  {
                      propertyBag["IsChecked"] = true;
                      index++;
                  }
              }
              Source.Add (propertyBag);
           }

           myDataGrid.DataSource = Source;
            if(! IsPostBack)
                DataBind();
        }

        protected void Submit_Click(Object sender, EventArgs evt)
        {
            
           String s = "";
        
            for (int i=0; i<myDataGrid.Items.Count; i++)
            {
              if( ((HtmlInputCheckBox) myDataGrid.Items[i].FindControl("mSelected")).Checked )
                   s += (i+1) + ",";
            }

            char[] comma = {','};

            UserState["SiteDirectory_Links"] = s.TrimEnd(comma);
            Response.Redirect("/quickstart/aspplus/samples/portal/default.aspx"); 

       
        }

    </script>

</head>

<body bgcolor="ffffff" style="margin:0,0,0,0">

<Portal:PageHeader runat="server"/>
<Portal:EditModuleHeader Title="Site Directory" runat="server"/>

    <form runat="server">

        <table>
            <tr>
                <td style="padding:15,15,15,15">

                    <font face="Arial" size="-1">Select the links to display on the Site Directory module, then click "Submit Changes" to accept the settings.</font>
                    <p>
 

                     <asp:DataGrid id="myDataGrid" runat="server" AutoGenerateColumns="False" showfooter="false" 
                        gridlines=none borderstyle=none borderwidth=0>
                        <property name="columns">
                          <asp:TemplateColumn>
                            <template name="ItemTemplate">
                              <input type="checkbox" Checked=<%#((Hashtable)Container.DataItem)["IsChecked"] %> id="mSelected" runat="server" >
                              <a style="color:blue;font:10pt verdana, arial" HRef=<%#((Hashtable) Container.DataItem)["LinkRef"] %>
                              InnerHTML=<%# ((Hashtable) Container.DataItem)["LinkName"] %> runat="server" id="Link" />  
                               
                            </template>
                          </asp:TemplateColumn>
                        </property>
                      </asp:DataGrid>




                </td>
            </tr>
        </table>

        <table width="100%" cellpadding="0" cellspacing="0" bgcolor="<%=UserState["SubheadColor"]%>">
            <tr><td align="center" width="100%" style="padding:10,10,10,10;border-color:black;border-style:solid;border-width:1;border-left:0;border-right:0;border-bottom:0" >
                <input type="submit" value="Submit Changes" runat="server" OnServerClick="Submit_Click">
            </td></tr>
        </table>

<Portal:EditModuleFooter runat="server"/>

</form>
</body>
</html>