<%@ Page Inherits="PortalModule" Description="Customize/Add Module Page" %>
<%@ Register TagName="PageHeader" TagPrefix="PageHeader" Src="/QuickStart/aspplus/samples/portal/include/PageHeader.aspx" %>

<%@ Import Namespace="System.Web.UI.HtmlControls" %>
<%@ Import Namespace="System.Collections" %>
<%@ Import Namespace="System.Data" %> 
<%@ Import Namespace="System.Data.SQL" %>

<html>
<head>

    <script language="C#" runat="server">

        public int pageIndex;
        public String pageName;
        public ArrayList Source;
        public String [] pageList;

        protected void Page_Load(Object sender, EventArgs e) 
        { 
             SQLDataSetCommand myAdapter = new SQLDataSetCommand(); 

            String dsn = (String) ((Hashtable) Context.GetConfig("dsnstore"))["portaldb"];
            myAdapter.SelectCommand.ActiveConnection = new SQLConnection(dsn) ; 
            myAdapter.SelectCommand.CommandText =  "GetPublicModules";
            myAdapter.SelectCommand.CommandType = CommandType.StoredProcedure;
            DataSet myDataSet = new DataSet();
            myAdapter.FillDataSet(myDataSet,"Results");

            if (Request.Cookies["_PageIndex"] != null) {
                pageIndex = Int32.Parse(Request.Cookies["_PageIndex"].Value);
            }
            else 
            {
                pageIndex = 0; 
            }

            String pageNames = UserState["PageNames"];

            pageList = pageNames.Split(new char[] { ';' });

            pageName = pageList[pageIndex];

            Hashtable moduleHash = new Hashtable();

            String leftModules = UserState["PageModules_" + pageIndex + "L"];
            if (leftModules != null) 
            {
                String [] leftModuleList = leftModules.Split(new char[] {';'});
                for (int i=0;i<leftModuleList.Length;i++) 
                   moduleHash[leftModuleList[i]] = true;
            }

            String rightModules = UserState["PageModules_" + pageIndex + "R"];
            if (rightModules != null) 
            {
                String [] rightModuleList = rightModules.Split(new char[] {';'});
                for (int i=0;i<rightModuleList.Length;i++) 
                   moduleHash[rightModuleList[i]] = true;
            }

            RowsCollection rows = myDataSet.Tables[0].Rows;
            DataColumn [] columns  = myDataSet.Tables[0].Columns.All;

            Source = new ArrayList();

            for (int i=0; i<rows.Count; i++) {

               Hashtable propertyBag = new Hashtable();

               for (int j=0; j<columns.Length;j++) {
                  Object value = myDataSet.Tables[0].Rows[i][columns[j]];
                  propertyBag[columns[j].ToString()] = (value== null) ? "" : value.ToString();
               }

               if (moduleHash[propertyBag["Source"]] != null)
                   propertyBag["IsChecked"] = true;
               else
                   propertyBag["IsChecked"] = false;

               Source.Add (propertyBag);
            }

            myDataGrid.DataSource = Source;
            if(! IsPostBack)
                DataBind();
        }
  
    public void Submit_Click(Object sender, EventArgs evt)
    {
        String sLeft = "";
        String sRight = "";
        for (int i=0; i<myDataGrid.Items.Count; i++)
        {
              if( ((HtmlInputCheckBox) myDataGrid.Items[i].FindControl("mSelected")).Checked )
                 
                  if (String.Compare (((Label) myDataGrid.Items[i].FindControl("mType")).Text ,"L") == 0)
                      sLeft += ((Hashtable)Source[i])["Source"] + ";";
                  else
                      sRight += ((Hashtable)Source[i])["Source"] + ";";
            }

            if (Request.Cookies["_PageIndex"] == null)
                pageIndex = 0;

            char[] semi = {';'};
            if (String.Compare(UserState["UserId"],"ANONYMOUS") != 0) 
            {
                UserState["PageModules_" + pageIndex + "L"] = sLeft.TrimEnd(semi);
                UserState["PageModules_" + pageIndex + "R"] = sRight.TrimEnd(semi);
            }

            pageList[pageIndex] = txtPageName.Value; 
            String s = "";
            for (int i=0; i<pageList.Length; i++)
                s += pageList[i] + ";";

            UserState["PageNames"] = s.TrimEnd(semi); 

            Response.Redirect("/quickstart/aspplus/samples/portal/default.aspx");  
    }

 
    </script>

</head>

<body bgcolor="ffffff" style="margin:0,0,0,0">
<form  runat="server" >

<PageHeader:PageHeader runat="server"/>

<table border=0 width="100%" cellspacing=0 cellpadding=0 style="padding:0,0,0,0">
    <tr align=left>
      <td bgcolor="<%# UserState["HeadColor"]%>" height="35" style="padding:0,0,0,15;border-color:black;border-style:solid; border-width:1;border-right:0;border-left:0;border-bottom:0"><font face=Arial color="white">&nbsp;<b>Personalize This Page</b></font>&nbsp;</td>
    </tr>
    <tr>
      <td width="100%" valign="top">
        <table border=0 width="100%" cellspacing=0 cellpadding=0>
          <tr>
            <td>
              <!--BEGIN MODULE-->
                <table width="100%" cellpadding=5 cellspacing=0>
                  <tr>
                    <td align="left" height="75" bgcolor="<%# UserState["SubheadColor"]%>" style="padding:15,15,15,20;border-color:black;border-style:solid; border-width:1;border-right:0;border-left:0">
                     <font face="Arial"><b>Page Name</b></font> &nbsp;&nbsp;<input type="text" id="txtPageName" value=<%# pageName %> size="35" runat="server"/>
                    </td>
                    <td align="right" bgcolor="<%# UserState["SubheadColor"]%>" style="padding:15,15,15,15;border-color:black;border-style:solid;border-width:1;border-left:0;border-right:0">
                        <input type="submit" value="Submit Changes" OnServerClick="Submit_Click" runat="server"/>
                    </td>
                  </tr>
                  <tr bgcolor="ffffff">
                    <td align="left" colspan="2" width="50%" height="25" style="padding:15,15,15,15;border-color:black;border-style:solid;                            border-top:0;border-width:1;border-right:0;border-left:0">
                      <asp:DataGrid id="myDataGrid" runat="server" AutoGenerateColumns="False" showfooter="false" 
                        gridlines=none borderstyle=none borderwidth=0>
                        <property name="columns">
                          <asp:TemplateColumn>
                            <template name="ItemTemplate">
                              <input type="checkbox" Checked=<%#((Hashtable)Container.DataItem)["IsChecked"] %> id="mSelected" runat="server" >
                              <a target="_new" style="color:blue;font:10pt verdana, arial" HRef=<%#((Hashtable) Container.DataItem)["DemoSource"] %>
                              InnerHTML=<%# ((Hashtable) Container.DataItem)["Name"] %> runat="server"/>  
                              <font size="-2">&nbsp;( <asp:label text=<%# ((Hashtable) Container.DataItem)["Type"] %> id="mType" runat="server"/> ) </font><br>
                              <asp:label style="color:black;font:8pt verdana, arial" text=<%# ((Hashtable) Container.DataItem)["Description"] %> runat="server"/><p> 
                            </template>
                          </asp:TemplateColumn>
                        </property>
                      </asp:DataGrid>
                    </td>
                  </tr>
                  <tr bgcolor="<%# UserState["SubheadColor"]%>">
                    <td align="left" height="55" style="border-color:black;border-style:solid;                          border-width:1;border-top:0;border-right:0;border-left:0"> &nbsp;
                    </td>
                    <td align="right"                    style="padding:15,15,15,15;border-color:black;border-style:solid;border-width:1;border-top:0;border-right:0;border-left:0">
                      <input type="submit" value="Submit Changes" OnServerClick="Submit_Click" runat="server"/>
                    </td>
                  </tr>
                </table>
                <!--END MODULE-->
              </td>
            </tr>
          </table>
        </td>
    </tr>
</table>

</form>
</body>
</html>